export type KeyDetails = {
  key: any;
  code: any;
  shiftKey: any;
  time: number | null;
};

export type Aspects = {
  dd: number | boolean;
  flight: number | boolean;
  full: number | boolean;
  hold: number | boolean;
};

export type Stat = {
  standard: {
    distance: Aspects;
    inRange: Aspects;
    inRangePercent: Aspects;
    threshold: number;
    sd: number;
  };
  filtered: {
    distance: Aspects;
    inRange: Aspects;
    inRangePercent: Aspects;
    threshold: number;
    sd: number;
  };
  mahalanobis: {
    threshold: number;
    normedDistance: Aspects;
    distance: Aspects;
    inRange: Aspects;
  };
  fullStandard: {
    threshold: number;
    normedDistance: Aspects;
    distance: Aspects;
    inRange: Aspects;
  };
  fullFiltered: {
    threshold: number;
    normedDistance: Aspects;
    distance: Aspects;
    inRange: Aspects;
  };
  accepted: boolean;
};

export type KeystrokeType = {
  hold: number[];
  flight: number[];
  dd: number[];
  full: number[];
};

export type Result = {
  attempt: KeystrokeType;
  db: KeystrokeType;
  filteredDb: KeystrokeType;
  result: Stat | null;
};
